Index: trunk/src/world_entities/creatures/fps_player.cc
===================================================================
--- trunk/src/world_entities/creatures/fps_player.cc	(revision 10510)
+++ trunk/src/world_entities/creatures/fps_player.cc	(revision 10511)
@@ -341,5 +341,5 @@
 if( this->bJump)
     {
-      printf("dummyvariable:( %f, %f, %f) \n", this->getAbsCoorX(), this->getAbsCoorY(), this->getAbsCoorZ() );
+      printf("panicGuy:runTo( %f, %f, %f ) \n", this->getAbsCoorX(), this->getAbsCoorY(), this->getAbsCoorZ() );
       this->bJump = false;
      }
Index: trunk/src/world_entities/effects/blink.cc
===================================================================
--- trunk/src/world_entities/effects/blink.cc	(revision 10510)
+++ trunk/src/world_entities/effects/blink.cc	(revision 10511)
@@ -63,5 +63,5 @@
 
   this->bBoard = new Billboard;
-  this->bBoard->setVisibiliy(true);
+  this->bBoard->setVisibility(true);
   this->bBoard->setTexture("textures/light/blink.png");
 
Index: trunk/src/world_entities/effects/trail.cc
===================================================================
--- trunk/src/world_entities/effects/trail.cc	(revision 10510)
+++ trunk/src/world_entities/effects/trail.cc	(revision 10511)
@@ -94,5 +94,5 @@
 
   this->setAbsCoor(0, 0, 0);
-  this->setVisibiliy(true);
+  this->setVisibility(true);
 
   this->nodeList[0] = (this->getAbsCoor());
Index: trunk/src/world_entities/npcs/generic_npc.cc
===================================================================
--- trunk/src/world_entities/npcs/generic_npc.cc	(revision 10510)
+++ trunk/src/world_entities/npcs/generic_npc.cc	(revision 10511)
@@ -48,6 +48,5 @@
                         ->addMethod("playAnimation", Executor2<GenericNPC, lua_State*,int,int>(&GenericNPC::playAnimation))
                         // Display
-                        ->addMethod("hide", Executor0<WorldEntity, lua_State*>(&WorldEntity::hide))
-                        ->addMethod("unhide", Executor0<WorldEntity, lua_State*>(&WorldEntity::unhide))
+                        ->addMethod("setVisibility", Executor1<WorldEntity, lua_State*, bool>(&WorldEntity::setVisibility))
                         // Coordinates
                         ->addMethod("getAbsCoorX", Executor0ret<PNode, lua_State*, float>(&PNode::getAbsCoorX))
Index: trunk/src/world_entities/npcs/npc.cc
===================================================================
--- trunk/src/world_entities/npcs/npc.cc	(revision 10510)
+++ trunk/src/world_entities/npcs/npc.cc	(revision 10511)
@@ -65,6 +65,5 @@
                         ->addMethod("fire", Executor0<NPC, lua_State*>(&NPC::fire))
                         ->addMethod("pause", Executor1<WorldEntity, lua_State*, bool>(&WorldEntity::pauseTrack))
-                        ->addMethod("hide", Executor0<WorldEntity, lua_State*>(&WorldEntity::hide))
-                        ->addMethod("unhide", Executor0<WorldEntity, lua_State*>(&WorldEntity::unhide))
+                        ->addMethod("setVisibility", Executor1<WorldEntity, lua_State*, bool>(&WorldEntity::setVisibility))
                        );
 
Index: trunk/src/world_entities/projectiles/acid_splash.cc
===================================================================
--- trunk/src/world_entities/projectiles/acid_splash.cc	(revision 10510)
+++ trunk/src/world_entities/projectiles/acid_splash.cc	(revision 10511)
@@ -54,5 +54,5 @@
   this->grid = new Wobblegrid( 5);
   this->grid->setParent( this);
-  this->grid->setVisibiliy(false);
+  this->grid->setVisibility(false);
 
 
@@ -99,5 +99,5 @@
   this->toList(OM_ENVIRON);
  // this->unhide();
-  this->grid->setVisibiliy(true);
+  this->grid->setVisibility(true);
 
   this->setPhysDamage(10);
@@ -112,5 +112,5 @@
 
  // this->hide();
-  this->grid->setVisibiliy(false);
+  this->grid->setVisibility(false);
   this->lifeCycle = 0.0;
   this->toList(OM_NULL);
Index: trunk/src/world_entities/projectiles/hbolt.cc
===================================================================
--- trunk/src/world_entities/projectiles/hbolt.cc	(revision 10510)
+++ trunk/src/world_entities/projectiles/hbolt.cc	(revision 10511)
@@ -59,5 +59,5 @@
   this->halo->setSize(.65, .65);
   this->halo->setTexture("hbolt_halo2.png");
-  this->halo->setVisibiliy(false);
+  this->halo->setVisibility(false);
 
 }
@@ -86,5 +86,5 @@
 void HBolt::activate()
 {
-  this->halo->setVisibiliy(true);
+  this->halo->setVisibility(true);
   this->origList = this->getOMListNumber();
   this->toList(OM_ENVIRON);
@@ -109,5 +109,5 @@
 void HBolt::deactivate()
 {
-  this->halo->setVisibiliy(false);
+  this->halo->setVisibility(false);
   assert (HBolt::explosionParticles != NULL);
   HBolt::explosionParticles->removeEmitter(this->emitter);
Index: trunk/src/world_entities/projectiles/lbolt.cc
===================================================================
--- trunk/src/world_entities/projectiles/lbolt.cc	(revision 10510)
+++ trunk/src/world_entities/projectiles/lbolt.cc	(revision 10511)
@@ -62,5 +62,5 @@
   this->halo->setSize(.35, .35);
   this->halo->setTexture("hbolt_halo.png");
-  this->halo->setVisibiliy(false);
+  this->halo->setVisibility(false);
 
 
@@ -90,5 +90,5 @@
 void LBolt::activate()
 {
-  this->halo->setVisibiliy(true);
+  this->halo->setVisibility(true);
   this->origList = this->getOMListNumber();
   this->toList(OM_ENVIRON);
@@ -115,5 +115,5 @@
   assert (LBolt::explosionParticles != NULL);
   LBolt::explosionParticles->removeEmitter(this->emitter);
-  this->halo->setVisibiliy(false);
+  this->halo->setVisibility(false);
   this->lifeCycle = 0.0;
 
Index: trunk/src/world_entities/projectiles/spike_ball.cc
===================================================================
--- trunk/src/world_entities/projectiles/spike_ball.cc	(revision 10510)
+++ trunk/src/world_entities/projectiles/spike_ball.cc	(revision 10511)
@@ -60,5 +60,5 @@
   this->halo->setSize(2, 2);
   this->halo->setTexture("hbolt_halo.png");
-  this->halo->setVisibiliy(false);
+  this->halo->setVisibility(false);
 
   this->setFragments(26);
@@ -95,5 +95,5 @@
 void SpikeBall::activate()
 {
-  this->halo->setVisibiliy(true);
+  this->halo->setVisibility(true);
   if (unlikely(SpikeBall::explosionParticles == NULL))
   {
@@ -142,5 +142,5 @@
 void SpikeBall::deactivate()
 {
-  this->halo->setVisibiliy(false);
+  this->halo->setVisibility(false);
   assert (SpikeBall::explosionParticles != NULL);
   //SpikeBall::explosionParticles->removeEmitter(this->emitter);
Index: trunk/src/world_entities/weather_effects/lightning_effect.cc
===================================================================
--- trunk/src/world_entities/weather_effects/lightning_effect.cc	(revision 10510)
+++ trunk/src/world_entities/weather_effects/lightning_effect.cc	(revision 10511)
@@ -107,5 +107,5 @@
         this->thunderBolt[i] = new Billboard(NULL);
         this->thunderBolt[i]->setSize(this->width, this->height);
-        this->thunderBolt[i]->setVisibiliy(false);
+        this->thunderBolt[i]->setVisibility(false);
     }
 
@@ -176,5 +176,5 @@
     int i;
     for (i = 0; i < 4; i++)
-        this->thunderBolt[i]->setVisibiliy(false);
+        this->thunderBolt[i]->setVisibility(false);
 
 }
@@ -197,5 +197,5 @@
 
         // Start a flash & lightning cycle
-        this->thunderBolt[0]->setVisibiliy(true);
+        this->thunderBolt[0]->setVisibility(true);
 
         // Lighten up environment
@@ -209,17 +209,17 @@
 
     if( this->thunderBolt[0]->isVisible() && this->time > this->flashRisingTime*1/3 ) {
-        this->thunderBolt[0]->setVisibiliy(false);
-        this->thunderBolt[1]->setVisibiliy(true);
+        this->thunderBolt[0]->setVisibility(false);
+        this->thunderBolt[1]->setVisibility(true);
     } else if( this->thunderBolt[1]->isVisible() && this->time > this->flashRisingTime*2/3 ) {
-        this->thunderBolt[1]->setVisibiliy(false);
-        this->thunderBolt[2]->setVisibiliy(true);
+        this->thunderBolt[1]->setVisibility(false);
+        this->thunderBolt[2]->setVisibility(true);
 
     } else if( this->thunderBolt[2]->isVisible() && this->time > this->flashRisingTime) {
-        this->thunderBolt[2]->setVisibiliy(false);
-        this->thunderBolt[3]->setVisibiliy(true);
+        this->thunderBolt[2]->setVisibility(false);
+        this->thunderBolt[3]->setVisibility(true);
     }
 
     if( this->thunderBolt[3]->isVisible() && this->time > this->flashHoldTime) {
-        this->thunderBolt[3]->setVisibiliy(false);
+        this->thunderBolt[3]->setVisibility(false);
 
         this->time = 0.0f;
Index: trunk/src/world_entities/world_entity.cc
===================================================================
--- trunk/src/world_entities/world_entity.cc	(revision 10510)
+++ trunk/src/world_entities/world_entity.cc	(revision 10511)
@@ -717,4 +717,6 @@
 void WorldEntity::draw(const Model* model) const
 {
+  if(bVisible)
+  {
   glMatrixMode(GL_MODELVIEW);
   glPushMatrix();
@@ -733,4 +735,5 @@
 
   glPopMatrix();
+  }
 }
 
Index: trunk/src/world_entities/world_entity.h
===================================================================
--- trunk/src/world_entities/world_entity.h	(revision 10510)
+++ trunk/src/world_entities/world_entity.h	(revision 10511)
@@ -64,5 +64,5 @@
 
   /** @param visibility if the Entity should be visible (been draw) */
-  void setVisibiliy (bool visibility) { this->bVisible = visibility; };
+  void setVisibility (bool visibility) { this->bVisible = visibility; };
   /** @returns true if the entity is visible, false otherwise */
   inline bool isVisible() const { return this->bVisible; };