Index: /code/branches/core7/src/libraries/core/CMakeLists.txt
===================================================================
--- /code/branches/core7/src/libraries/core/CMakeLists.txt	(revision 10530)
+++ /code/branches/core7/src/libraries/core/CMakeLists.txt	(revision 10531)
@@ -45,4 +45,5 @@
   Core.cc
   CoreConfig.cc
+  CoreStaticInitializationHandler.cc
 
 BUILD_UNIT OgreBuildUnit.cc
Index: /code/branches/core7/src/libraries/core/Core.cc
===================================================================
--- /code/branches/core7/src/libraries/core/Core.cc	(revision 10530)
+++ /code/branches/core7/src/libraries/core/Core.cc	(revision 10531)
@@ -123,4 +123,5 @@
         this->dynLibManager_ = new DynLibManager();
 
+        // TODO: initialize StaticInitializationManager
         // TODO: initialize Root-Context
         // TODO: initialize IdentifierManager here
Index: /code/branches/core7/src/libraries/core/CorePrereqs.h
===================================================================
--- /code/branches/core7/src/libraries/core/CorePrereqs.h	(revision 10530)
+++ /code/branches/core7/src/libraries/core/CorePrereqs.h	(revision 10531)
@@ -207,4 +207,6 @@
     class SmartPtr;
     class StaticallyInitializedInstance;
+    class StaticInitializationHandler;
+    class StaticInitializationManager;
     template <class T>
     class SubclassIdentifier;
Index: /code/branches/core7/src/libraries/core/CoreStaticInitializationHandler.cc
===================================================================
--- /code/branches/core7/src/libraries/core/CoreStaticInitializationHandler.cc	(revision 10531)
+++ /code/branches/core7/src/libraries/core/CoreStaticInitializationHandler.cc	(revision 10531)
@@ -0,0 +1,33 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "CoreStaticInitializationHandler.h"
+
+namespace orxonox
+{
+}
Index: /code/branches/core7/src/libraries/core/CoreStaticInitializationHandler.h
===================================================================
--- /code/branches/core7/src/libraries/core/CoreStaticInitializationHandler.h	(revision 10531)
+++ /code/branches/core7/src/libraries/core/CoreStaticInitializationHandler.h	(revision 10531)
@@ -0,0 +1,46 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _CoreStaticInitializationHandler_H__
+#define _CoreStaticInitializationHandler_H__
+
+#include "core/CorePrereqs.h"
+
+#include "module/StaticInitializationHandler.h"
+
+namespace orxonox
+{
+    class _CoreExport CoreStaticInitializationHandler : public StaticInitializationHandler
+    {
+        public:
+            CoreStaticInitializationHandler() {}
+            virtual ~CoreStaticInitializationHandler() {}
+    };
+}
+
+#endif /* _CoreStaticInitializationHandler_H__ */
Index: /code/branches/core7/src/libraries/core/module/CMakeLists.txt
===================================================================
--- /code/branches/core7/src/libraries/core/module/CMakeLists.txt	(revision 10530)
+++ /code/branches/core7/src/libraries/core/module/CMakeLists.txt	(revision 10531)
@@ -2,3 +2,6 @@
   ModuleInstance.cc
   StaticallyInitializedInstance.cc
+  StaticInitializationHandler.cc
+  StaticInitializationHandlerIncludes.cc
+  StaticInitializationManager.cc
 )
Index: /code/branches/core7/src/libraries/core/module/StaticInitializationHandler.cc
===================================================================
--- /code/branches/core7/src/libraries/core/module/StaticInitializationHandler.cc	(revision 10531)
+++ /code/branches/core7/src/libraries/core/module/StaticInitializationHandler.cc	(revision 10531)
@@ -0,0 +1,33 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "StaticInitializationHandler.h"
+
+namespace orxonox
+{
+}
Index: /code/branches/core7/src/libraries/core/module/StaticInitializationHandler.h
===================================================================
--- /code/branches/core7/src/libraries/core/module/StaticInitializationHandler.h	(revision 10531)
+++ /code/branches/core7/src/libraries/core/module/StaticInitializationHandler.h	(revision 10531)
@@ -0,0 +1,44 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _StaticInitializationHandler_H__
+#define _StaticInitializationHandler_H__
+
+#include "core/CorePrereqs.h"
+
+namespace orxonox
+{
+    class _CoreExport StaticInitializationHandler
+    {
+        public:
+            StaticInitializationHandler() {}
+            virtual ~StaticInitializationHandler() {}
+    };
+}
+
+#endif /* _StaticInitializationHandler_H__ */
Index: /code/branches/core7/src/libraries/core/module/StaticInitializationHandlerIncludes.cc
===================================================================
--- /code/branches/core7/src/libraries/core/module/StaticInitializationHandlerIncludes.cc	(revision 10531)
+++ /code/branches/core7/src/libraries/core/module/StaticInitializationHandlerIncludes.cc	(revision 10531)
@@ -0,0 +1,44 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "StaticInitializationHandlerIncludes.h"
+
+#include "StaticInitializationManager.h"
+
+namespace orxonox
+{
+    void StaticallyInitializedStaticInitializationHandler::load()
+    {
+        StaticInitializationManager::getInstance().addHandler(this->handler_);
+    }
+
+    void StaticallyInitializedStaticInitializationHandler::unload()
+    {
+        StaticInitializationManager::getInstance().removeHandler(this->handler_);
+    }
+}
Index: /code/branches/core7/src/libraries/core/module/StaticInitializationHandlerIncludes.h
===================================================================
--- /code/branches/core7/src/libraries/core/module/StaticInitializationHandlerIncludes.h	(revision 10531)
+++ /code/branches/core7/src/libraries/core/module/StaticInitializationHandlerIncludes.h	(revision 10531)
@@ -0,0 +1,68 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _StaticInitializationHandlerIncludes_H__
+#define _StaticInitializationHandlerIncludes_H__
+
+#include "core/CorePrereqs.h"
+
+#include "StaticInitializationHandler.h"
+#include "StaticallyInitializedInstance.h"
+
+/**
+ * Registers a StaticInitializationHandler
+ */
+#define RegisterStaticInitializationHandler(className) \
+    static StaticInitializationHandler& className##StaticInitializationHandler \
+        = (new orxonox::SI_SIH(new className()))->getHandler()
+
+namespace orxonox
+{
+    class _CoreExport StaticallyInitializedStaticInitializationHandler : public StaticallyInitializedInstance
+    {
+        public:
+            StaticallyInitializedStaticInitializationHandler(StaticInitializationHandler* handler)
+                : StaticallyInitializedInstance(0)
+                , handler_(handler)
+            {}
+            ~StaticallyInitializedStaticInitializationHandler() { delete handler_; }
+
+            virtual void load();
+            virtual void unload();
+
+            inline StaticInitializationHandler& getHandler()
+                { return *this->handler_; }
+
+        private:
+            StaticInitializationHandler* handler_;
+    };
+
+    typedef StaticallyInitializedStaticInitializationHandler SI_SIH;
+}
+
+#endif /* _StaticInitializationHandlerIncludes_H__ */
Index: /code/branches/core7/src/libraries/core/module/StaticInitializationManager.cc
===================================================================
--- /code/branches/core7/src/libraries/core/module/StaticInitializationManager.cc	(revision 10531)
+++ /code/branches/core7/src/libraries/core/module/StaticInitializationManager.cc	(revision 10531)
@@ -0,0 +1,53 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#include "StaticInitializationManager.h"
+
+namespace orxonox
+{
+    /* static */ StaticInitializationManager& StaticInitializationManager::getInstance()
+    {
+        static StaticInitializationManager instance;
+        return instance;
+    }
+
+    void StaticInitializationManager::addHandler(StaticInitializationHandler* handler)
+    {
+        this->handlers_.push_back(handler);
+    }
+
+    void StaticInitializationManager::removeHandler(StaticInitializationHandler* handler)
+    {
+        this->handlers_.remove(handler);
+    }
+
+    void StaticInitializationManager::addCoreHandler()
+    {
+        // TODO
+    }
+}
Index: /code/branches/core7/src/libraries/core/module/StaticInitializationManager.h
===================================================================
--- /code/branches/core7/src/libraries/core/module/StaticInitializationManager.h	(revision 10531)
+++ /code/branches/core7/src/libraries/core/module/StaticInitializationManager.h	(revision 10531)
@@ -0,0 +1,58 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *                    > www.orxonox.net <
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Fabian 'x3n' Landau
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+#ifndef _StaticInitializationManager_H__
+#define _StaticInitializationManager_H__
+
+#include "core/CorePrereqs.h"
+
+#include <list>
+
+namespace orxonox
+{
+    class _CoreExport StaticInitializationManager
+    {
+        friend class Core;
+
+        public:
+            static StaticInitializationManager& getInstance();
+
+            StaticInitializationManager() {}
+            virtual ~StaticInitializationManager() {}
+
+            void addHandler(StaticInitializationHandler* handler);
+            void removeHandler(StaticInitializationHandler* handler);
+
+        private:
+            void addCoreHandler();
+
+            std::list<StaticInitializationHandler*> handlers_;
+    };
+}
+
+#endif /* _StaticInitializationManager_H__ */