Index: code/branches/core7/test/core/class/IdentifiableTest.cc
===================================================================
--- code/branches/core7/test/core/class/IdentifiableTest.cc	(revision 10532)
+++ code/branches/core7/test/core/class/IdentifiableTest.cc	(revision 10533)
@@ -2,4 +2,5 @@
 #include "core/CoreIncludes.h"
 #include "core/class/Identifiable.h"
+#include "core/module/ModuleInstance.h"
 
 namespace orxonox
@@ -7,30 +8,45 @@
     namespace
     {
-        class IdentifiableTest : public Identifiable
+        class IdentifiableClass : public Identifiable
         {
             public:
-                IdentifiableTest() { RegisterObject(IdentifiableTest); }
+                IdentifiableClass() { RegisterObject(IdentifiableClass); }
         };
 
-        RegisterClassNoArgs(IdentifiableTest);
+        RegisterClassNoArgs(IdentifiableClass);
+
+        // Fixture
+        class IdentifiableTest : public ::testing::Test
+        {
+            public:
+                virtual void SetUp()
+                {
+                    ModuleInstance::getCurrentModuleInstance()->loadAllStaticallyInitializedInstances();
+                }
+
+                virtual void TearDown()
+                {
+                    ModuleInstance::getCurrentModuleInstance()->unloadAllStaticallyInitializedInstances();
+                }
+        };
     }
 
-    TEST(IdentifiableTest, CanCreate)
+    TEST_F(IdentifiableTest, CanCreate)
     {
-        IdentifiableTest* test = new IdentifiableTest();
+        IdentifiableClass* test = new IdentifiableClass();
         ASSERT_TRUE(test != NULL);
         delete test;
     }
 
-    TEST(IdentifiableTest, HasIdentifierAssigned)
+    TEST_F(IdentifiableTest, HasIdentifierAssigned)
     {
-        IdentifiableTest test;
+        IdentifiableClass test;
         EXPECT_TRUE(test.getIdentifier());
     }
 
-    TEST(IdentifiableTest, CanBeIdentified)
+    TEST_F(IdentifiableTest, CanBeIdentified)
     {
-        IdentifiableTest test;
-        EXPECT_TRUE(test.isA(Class(IdentifiableTest)));
+        IdentifiableClass test;
+        EXPECT_TRUE(test.isA(Class(IdentifiableClass)));
     }
 }
Index: code/branches/core7/test/core/class/IdentifierClassHierarchyTest.cc
===================================================================
--- code/branches/core7/test/core/class/IdentifierClassHierarchyTest.cc	(revision 10532)
+++ code/branches/core7/test/core/class/IdentifierClassHierarchyTest.cc	(revision 10533)
@@ -165,58 +165,4 @@
     }
 
-    TEST(IdentifierClassHierarchyTest_NoFixture, NoInitialization)
-    {
-        {
-            Identifier* identifier = Class(BaseInterface1);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(BaseInterface2);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(Interface1);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(Interface2);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(BaseClass);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(Class0);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(Class1);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(Class2a);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(Class2b);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(Class3);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-    }
-
     TEST_F(IdentifierClassHierarchyTest, TestBaseInterface1)
     {
Index: code/branches/core7/test/core/class/IdentifierExternalClassHierarchyTest.cc
===================================================================
--- code/branches/core7/test/core/class/IdentifierExternalClassHierarchyTest.cc	(revision 10532)
+++ code/branches/core7/test/core/class/IdentifierExternalClassHierarchyTest.cc	(revision 10533)
@@ -72,23 +72,4 @@
     }
 
-    TEST(IdentifierExternalClassHierarchyTest_NoFixture, NoInitialization)
-    {
-        {
-            Identifier* identifier = Class(Interface);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(BaseClass);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(RealClass);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-    }
-
     TEST_F(IdentifierExternalClassHierarchyTest, TestInterface)
     {
Index: code/branches/core7/test/core/class/IdentifierSimpleClassHierarchyTest.cc
===================================================================
--- code/branches/core7/test/core/class/IdentifierSimpleClassHierarchyTest.cc	(revision 10532)
+++ code/branches/core7/test/core/class/IdentifierSimpleClassHierarchyTest.cc	(revision 10533)
@@ -74,23 +74,4 @@
     }
 
-    TEST(IdentifierSimpleClassHierarchyTest_NoFixture, NoInitialization)
-    {
-        {
-            Identifier* identifier = Class(Interface);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(BaseClass);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-        {
-            Identifier* identifier = Class(RealClass);
-            EXPECT_EQ(0u, identifier->getChildren().size());
-            EXPECT_EQ(0u, identifier->getParents().size());
-        }
-    }
-
     TEST_F(IdentifierSimpleClassHierarchyTest, TestInterface)
     {
Index: code/branches/core7/test/core/class/IdentifierTest.cc
===================================================================
--- code/branches/core7/test/core/class/IdentifierTest.cc	(revision 10532)
+++ code/branches/core7/test/core/class/IdentifierTest.cc	(revision 10533)
@@ -2,4 +2,5 @@
 #include "core/CoreIncludes.h"
 #include "core/class/Identifiable.h"
+#include "core/module/ModuleInstance.h"
 
 namespace orxonox
@@ -21,7 +22,22 @@
         RegisterClassNoArgs(TestClass);
         RegisterClassNoArgs(TestSubclass);
+
+        // Fixture
+        class IdentifierTest : public ::testing::Test
+        {
+            public:
+                virtual void SetUp()
+                {
+                    ModuleInstance::getCurrentModuleInstance()->loadAllStaticallyInitializedInstances();
+                }
+
+                virtual void TearDown()
+                {
+                    ModuleInstance::getCurrentModuleInstance()->unloadAllStaticallyInitializedInstances();
+                }
+        };
     }
 
-    TEST(IdentifierTest, IdentifierExistsOfClass)
+    TEST_F(IdentifierTest, IdentifierExistsOfClass)
     {
         TestClass test;
@@ -31,5 +47,5 @@
     }
 
-    TEST(IdentifierTest, IdentifierExistsOfSubclass)
+    TEST_F(IdentifierTest, IdentifierExistsOfSubclass)
     {
         TestSubclass test;
@@ -39,5 +55,5 @@
     }
 
-    TEST(IdentifierTest, HasNameOfClass)
+    TEST_F(IdentifierTest, HasNameOfClass)
     {
         TestClass test;
@@ -47,5 +63,5 @@
     }
 
-    TEST(IdentifierTest, HasNameOfSubClass)
+    TEST_F(IdentifierTest, HasNameOfSubClass)
     {
         TestSubclass test;